diff --git a/web/pgadmin/utils/tests/test_versioned_template_loader.py b/web/pgadmin/utils/tests/test_versioned_template_loader.py
index 46fefeca..a4739a85 100644
--- a/web/pgadmin/utils/tests/test_versioned_template_loader.py
+++ b/web/pgadmin/utils/tests/test_versioned_template_loader.py
@@ -9,86 +9,26 @@
 
 import os
 
+import pytest
 from flask import Flask
+from grappa import should
 from jinja2 import FileSystemLoader
 from jinja2 import TemplateNotFound
 
 from pgadmin import VersionedTemplateLoader
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 
 
 class TestVersionedTemplateLoader(BaseTestGenerator):
-    scenarios = [
-        (
-            "Render a template when called",
-            dict(scenario=1)
-        ),
-        (
-            "Render a version 9.1 template when it is present",
-            dict(scenario=2)
-        ),
-        (
-            "Render a version 9.2 template when request for a higher version",
-            dict(scenario=3)
-        ),
-        (
-            "Render default version when version 9.0 was requested and only "
-            "9.1 and 9.2 are present",
-            dict(scenario=4)
-        ),
-        (
-            "Raise error when version is smaller than available templates",
-            dict(scenario=5)
-        ),
-        (
-            "Render a version GPDB 5.0 template when it is present",
-            dict(scenario=6)
-        ),
-        (
-            "Render a version GPDB 5.0 template when it is in default",
-            dict(scenario=7)
-        ),
-        (
-            "Raise error when version is gpdb but template does not exist",
-            dict(scenario=8)
-        )
-    ]
+    """Test Versioned template loader"""
 
-    def setUp(self):
+    @pytest.fixture(autouse=True)
+    def setup_tests(self):
+        setattr(self, 'setup_not_needed', True)
         self.loader = VersionedTemplateLoader(FakeApp())
 
-    def runTest(self):
-        if self.scenario == 1:
-            self.test_get_source_returns_a_template()
-        if self.scenario == 2:
-            # test_get_source_when_the_version_is_9_1_returns_9_1_template
-            self.test_get_source_when_the_version_is_9_1()
-        if self.scenario == 3:
-            # test_get_source_when_the_version_is_9_3_and_there_are_templates_
-            # for_9_2_and_9_1_returns_9_2_template
-            self.test_get_source_when_the_version_is_9_3()
-        if self.scenario == 4:
-            # test_get_source_when_the_version_is_9_0_and_there_are_templates_
-            # for_9_1_and_9_2_returns_default_template
-            self.test_get_source_when_the_version_is_9_0()
-        if self.scenario == 5:
-            # test_raise_not_found_exception_when_postgres_version_less_than_
-            # all_available_sql_templates
-            self.test_raise_not_found_exception()
-        if self.scenario == 6:
-            # test_get_source_when_the_version_is_gpdb_5_0_returns_gpdb_5_0_
-            # template
-            self.test_get_source_when_the_version_is_gpdb_5_0()
-        if self.scenario == 7:
-            # test_get_source_when_the_version_is_gpdb_5_0_returns_default_
-            # template
-            self.test_get_source_when_the_version_is_gpdb_5_0_returns_default()
-        if self.scenario == 8:
-            # test_raise_not_found_exception_when_the_version_is_gpdb_template
-            # _not_exist
-            self.test_raise_not_found_exception_when_the_version_is_gpdb()
-
     def test_get_source_returns_a_template(self):
+        """Render a template when called"""
         expected_content = "Some SQL" \
                            "\nsome more stuff on a new line\n"
         # For cross platform we join the SQL path
@@ -99,10 +39,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
         content, filename, up_to_dateness = self.loader.get_source(
             None, "some_feature/sql/9.1_plus/some_action.sql"
         )
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_1(self):
         """Render a version 9.1 template when it is present"""
@@ -117,10 +56,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#90100#/some_action.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_3(self):
         """Render a version 9.2 template when request for a higher version"""
@@ -133,10 +71,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#90300#/some_action.sql"
         )
 
-        self.assertEqual(
-            "Some 9.2 SQL", str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        "Some 9.2 SQL" | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_9_0(self):
         """Render default version when version 9.0 was requested and only
@@ -150,18 +87,15 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None,
             "some_feature/sql/#90000#/some_action_with_default.sql")
 
-        self.assertEqual("Some default SQL", str(content).replace("\r", ""))
-        self.assertIn(sql_path, filename)
+        "Some default SQL" | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_raise_not_found_exception(self):
         """Raise error when version is smaller than available templates"""
-        try:
-            self.loader.get_source(
-                None, "some_feature/sql/#10100#/some_action.sql"
-            )
-            self.fail("No exception raised")
-        except TemplateNotFound:
-            return
+        (lambda: self.loader.get_source(
+            None, "some_feature/sql/#10100#/some_action.sql"
+        )) | should.raises(TemplateNotFound)
 
     def test_get_source_when_the_version_is_gpdb_5_0(self):
         """Render a version GPDB 5.0 template when it is present"""
@@ -177,10 +111,9 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             "some_feature/sql/#gpdb#80323#/some_action_with_gpdb_5_0.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_get_source_when_the_version_is_gpdb_5_0_returns_default(self):
         """Render a version GPDB 5.0 template when it is in default"""
@@ -194,20 +127,15 @@ class TestVersionedTemplateLoader(BaseTestGenerator):
             None, "some_feature/sql/#gpdb#80323#/some_action_with_default.sql"
         )
 
-        self.assertEqual(
-            expected_content, str(content).replace("\r", "")
-        )
-        self.assertIn(sql_path, filename)
+        expected_content | should.be.equal.to(str(content).replace("\r", ""))
+
+        filename | should.contain.item(sql_path)
 
     def test_raise_not_found_exception_when_the_version_is_gpdb(self):
         """"Raise error when version is gpdb but template does not exist"""
-        try:
-            self.loader.get_source(
-                None, "some_feature/sql/#gpdb#50100#/some_action.sql"
-            )
-            self.fail("No exception raised")
-        except TemplateNotFound:
-            return
+        (lambda: self.loader.get_source(
+            None, "some_feature/sql/#gpdb#50100#/some_action.sql"
+        )) | should.raises(TemplateNotFound)
 
 
 class FakeApp(Flask):
diff --git a/web/regression/conftest.py b/web/regression/conftest.py
new file mode 100644
index 00000000..1f66b465
--- /dev/null
+++ b/web/regression/conftest.py
@@ -0,0 +1,35 @@
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+
+# def pytest_generate_tests(metafunc):
+#     print('\n\n\npytest_generate_tests\n\n\n')
+#     idlist = []
+#     argvalues = []
+#     for scenario in metafunc.cls.scenarios:
+#         idlist.append(scenario[0])
+#         items = scenario[1].items()
+#         argnames = [x[0] for x in items]
+#         argvalues.append(([x[1] for x in items]))
+#     metafunc.parametrize(argnames, argvalues, ids=idlist, scope="class")
+import sys
+
+
+def pytest_generate_tests(metafunc):
+    print('Generation next')
+    idlist = []
+    argvalues = []
+    argnames = []
+    print('output', file=sys.stderr)
+    for scenario in metafunc.cls.scenarios:
+        idlist.append(scenario[0])
+        items = scenario[1].items()
+        argnames = [x[0] for x in items]
+        argvalues.append(([x[1] for x in items]))
+        print('bamm', file=sys.stderr)
+    print('shebang', file=sys.stderr)
+    metafunc.parametrize(argnames, argvalues, ids=idlist, scope="class",
+                         indirect=False)
diff --git a/web/regression/feature_utils/base_feature_test.py b/web/regression/feature_utils/base_feature_test.py
index 568fc2e9..3fcb94bf 100644
--- a/web/regression/feature_utils/base_feature_test.py
+++ b/web/regression/feature_utils/base_feature_test.py
@@ -16,7 +16,7 @@ from datetime import datetime
 from copy import deepcopy
 
 import config as app_config
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 from regression.feature_utils.pgadmin_page import PgadminPage
 
 
diff --git a/web/regression/python_test_utils/sql_template_test_base.py b/web/regression/python_test_utils/sql_template_test_base.py
index e0521786..383d7962 100644
--- a/web/regression/python_test_utils/sql_template_test_base.py
+++ b/web/regression/python_test_utils/sql_template_test_base.py
@@ -7,7 +7,7 @@
 #
 ##########################################################################
 
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 from regression.python_test_utils import test_utils
 from pgadmin.utils.driver import DriverRegistry
 
diff --git a/web/regression/runtests.sh b/web/regression/runtests.sh
new file mode 100755
index 00000000..b4701d3b
--- /dev/null
+++ b/web/regression/runtests.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+
+web_dir=$(cd `dirname $0` && cd .. && pwd )
+export PYTHONPATH=$web_dir
+pytest $web_dir/pgadmin --json=test_result.json --resultlog=regression.log
